rbc-cli-tools
=============

Command Line Tools for the RBC Cloud

##Installation

The cli tools require a nodejs runtime and are installed using the node package manager (npm).

````
> npm install -g rbc-cli
````

Not that on *nix based systems and Macs, a global install command MUST be run using sudo.
 
One the tools are installed, verify the installation using the version command. The command SHOULD respond with a semantic version of the tools: M is the major version, m is the minor version, and b is the build increment. 

````
> rbc-cli -V
  M.m.b 
````

##General Str

###Common Usage

````
<rbc-tool> [options] <command> [arguments ..] 
````
The first entry is the name of the tool. The second argument is the command. All further arguments are interpretted in the context of the command. 

Options can be specified anywhere on the command line __AFTER__ the tool designation. The following commands are considered equivalent.

````
rbc-cli -e my-environment -v command
````
````
rbc-cli -v command -e my-environment
````
````
rbc-cli command -v -e my-environment
````

###Processing Options

The following switch are universal and have consistent semantics across the tools.

long    | short | meaning
----    | ----- | -------
version | V     | request the version of a tool
help    | H     | request help in the form of usage instructions
verbose | v     | execute the command with intermediate output
debug   | d     | execute the command in debug mode
force   | f     | force the command to ignore saftey considerations
no-color| C     | do not use color 

##Project Commands

* pwd
* init

###pwd

__Aliases__: _home_

This command will print the home directory of the current project. 

#####Arguments

None.

#####Return

Platform specific directory path of the current project.

#####Sample

````
> rbc-cli pwd
/path/to/project/root
````

###init

This command will establish the current directory as a new project by creating a new rbc-project.json file. This command will fail safely if an existing rbc-project.json file exists up the directory tree. A user may create a project in a subfolder by using the --force command line option.

````
> rbc-cli init [-f]
/path/to/new/project/root
````

#####Arguments

None.

#####Return

Platform specific directory path to the newly initialized project.

## app-tools
Documentation on app-tools is located [here](app-tools.md).