App Generator
=============

The resulting app created from `app-tools new-app <app-name> -t app-generator -m <type>`
is a list-detail app that shows the 20 most recent records of the specified type. The user can
click on a list item that specifies a specific record of the specified type to drill down
and see attributes of the chosen record. Note: the app only shows attributes of type "String",
"DateTime", and "Integer"; it only shows attributes where "multi" is set to false.

## Scope
In this README file you will learn how to publish the generated app to the cloud and see it in the
mobile container.

## Intended Audience
This tutorial is designed for a developer looking to publish the app generator app. This tutorial assumes the developer
already has npm and node installed on his or her computer, has valid credentials for a namespace, has
permission to create users, and has bodhi-cli set up.

## Tutorial

#### Install node modules

Install node modules in the app folder in order to use the grunt commands to build the app.

```
> cd <app name>

> npm install
```

#### Run app locally in the browser

Check to see how the app runs in the browser. This will compile the app's source code and copy it into
the /www folder and then serve up the index.html from there.

*NOTE: Make sure you are logged in as a user that has permission to see the type specified
in the app generation command.

```
> grunt localhost
```

You will now be able to see the app at https://localhost:3000.

#### Define profile definition

A profile needs to be created with the app. Add the following to the package.json.
*NOTE: The "Application" type must be included in order for people with the profile to see the app.

```
    “profile”: {
        “name”: “<PROFILE NAME>,
        “dml”: {
            “Application”: {
                “select”: {},
                “insert”: {},
                “delete”: {},
                “update”: {}
            },
            <TYPE>: {
                ...
            }
        }
    }

```

#### Publish app

Compile the app's source code into production ready code and put it in /www.

```
> grunt prod-build

> app-tools publish-app
```

#### Add a user with the newly created profile

Create a new user with the app profile so that user can see the app being served up in the cloud.

*NOTE: You need admin rights to create a new user.
*NOTE: Profile creation has a bug in it where the profile name is surrounded by quotes. ex. toa.”testProfile”; therefore
when you assign a user that profile, remember to surround the profile name with quotes.

```
> curl -is -X POST -H Content-Type:application/json -u admin__chops:admin__chops -d '{"username":"<USER NAME>","password":"<PASSWORD>”,"email":"test@rbc.com","profiles":["chops.<PROFILE NAME>"]}' <URL>
```

#### Check the app

View the app in the browser:

<API ENDPOINT>/apps/<APP NAME>/index.html

*NOTE: you need to be logged in as the user you just created in the above step.

View the app in the container by logging in as the user you just created.
