var fs          = require('fs-extra');
var path        = require('path');
var _           = require('./utils');

var PACKAGE_FILE = 'package.json';

var noop =  function(){};

function App(attr, name) {
    this.name = name;
    this.attributes = _.extend({}, attr);
    this.project = null;
    this.path = process.cwd() + '/apps/' + name;    // TODO: check if this is right
}

App.prototype = {

    // project
    isBound: function(){
        return this.project != null;
    },
    getProject: function(){
        return this.project;
    },
    setProject: function(project){
        this.project = project;
    },

    // attributes
    getAttributes: function() {
        return this.attributes;
    },
    patch: function(patch) {
        if(patch) this.attributes = _.extend(this.attributes, patch);
        return this;
    },

    // name
    getName: function() {
        return this.attributes.name;
    },
    setName: function(name) {
        this.attributes.name = name;
    },

    // version
    getVersion: function() {
        return this.attributes.version;
    },
    setVersion: function(version) {
        this.attributes.version = version;
    },

    // title
    getTitle: function() {
        return this.attributes.title;
    },
    setTitle: function(title) {
        this.attributes.title = title;
    },

    // description
    getDescription: function() {
        return this.attributes.description;
    },
    setDescription: function(description) {
        this.attributes.description = description;
    },

    // icon
    getIcon: function() {
        return this.attributes.icon;
    },
    setIcon: function(icon) {
        this.attributes.icon = icon;
    },

    // settings
    getSettings: function() {
        return this.attributes.settings;
    },
    setSettings: function(settings) {
        this.attributes.settings = settings;
    },

    // profile
    getProfile: function() {
        return this.attributes.profile;
    },
    setProfile: function(profile) {

        this.attributes.profile = profile;
    },

    // ASSUMPTIONS:
        // - setProfile has already been called or already have a entry for profile (profile: {name: "", dml: {}})

    setProfileType: function(type, actions) {



    },

    // Set/Get specific settings?

    // utilities
    toJSON: function() {
        return _.toDelimitedJson(this.attributes);
    },
    getPackageFile: function() {
        return path.join(process.cwd(), PACKAGE_FILE);
    },
    save: function(callback) {
        callback = callback || noop;
        fs.outputJson(this.getPackageFile(), this.getAttributes(), callback);
    },
    post: function() {
        // TODO - post to cloud
    }
};

module.exports = App;