module.exports = function ProjectController(project, options){

    var _  = require('../utils.js');

    /**
     * Show the working directory
     */
    function pwd(){
        console.log(process.cwd());
    }

    /**
     * Initialize the environment
     */
    function init(){

        /**
         *
         * if(project.exists && !forcing)
         *  refuse()
         * else
         *  project.init();
         *  project.save(function(err){
         *
         *  })
         */

        if(options.verbose) console.log('Attempting to initialize the a project ...');

        if((project.exists) && !(options.force)){
            console.log('Cowardly refusing to overwrite an existing project file');
            console.log(' - Please remove the existing project or use --force to reinitialize this directory');
        } else {
            project.init();
            project.save(function(err){
                if(err){
                    if(options.verbose) console.log('Unable to write the project file');
                    if(options.debug)   console.log(err);
                } else {
                    if(options.verbose) {
                        console.log('Project File Saved as' + project.getProjectFile());
                    } else {
                        console.log(project.getProjectFile());
                    }
                }
            });
        }
    }

    /**
     * Set the Default
     * @param name
     */
    function setDefault(name){
        if(project.hasEnvironment(name)){
            project.setDefaultEnvironment(name);
            project.save(function(err){
                if(err){
                    if(options.verbose) console.log('ERROR. Unable to write the project file');
                } else {
                    if(options.verbose) {
                        console.log('Project File Saved' + project.getProjectFile());
                    } else {
                        console.log(name);
                    }
                }
            })
        } else {
            console.error('Unknown Connection ' + name);
        }
    }

    /**
     * Get the Default
     */
    function getDefault(){
        //internal ...
        if(project.hasDefaultEnv()){
            console.log(project.getDefaultEnvironment())
        } else {
            console.log('Default Connection currently unspecified.')
        }
    }

    return {
           pwd         : pwd
        ,  init        : init
        ,  getDefault  : getDefault
        ,  setDefault  : setDefault
    }

}