/**
 * Library for formatting console messages.
 *
 * @param options
 * @returns {{fatal: fatal, error: error, info: info, verbose: verbose}}
 */


// TODO: look at good examples of log output!

module.exports = function(options) {

    options = options || {};

    'use strict';

    function fatal(msg, code) {
        code = code || 5;
        console.log(msg.red);
        process.exit(code);
    }

    function error(msg) {
        console.log(msg);
    }

    function info(msg) {
        console.log(msg);
    }

    function verbose(msg) {

        if (options.debug || options.verbose) {
            console.log('[verbose]'.green, msg);
        }
    }

    function debug(msg) {

        if (options.debug) {
            console.log('[debug]'.yellow, msg);
        }
    }

    return {
        fatal: fatal,
        error: error,
        info: info,
        verbose: verbose,
        debug: debug
    };
};
